/*=======================================

	cMyError::Implementation

	*See header file for more information
	
	By Matt Barnett;

=======================================*/

#include "myerror.h"
#include "leakdetect.h"

/*=======================================
cMyError::Constructor
=======================================*/

cMyError::cMyError()
{
#ifdef VERBOSE_CREATION
	printf("cMyError::Constructor::Empty\n");
#endif
}

/*=======================================
cMyError::Destructor
=======================================*/

cMyError::~cMyError()
{

#ifdef VERBOSE_CREATION
	printf("cMyError::Destructor::Empty\n");
#endif

}

/*=========================================================
void cMyError::FatalError()
==========================================================*/

void cMyError::FatalError(const char *strString, ...)
{
	char		strText[256];				// This will hold our text to display
	va_list		argumentPtr;				// This will hold the pointer to the argument list
	float		unitLength=0.0f;			// This will store the length of the 3D Font in unit length
		
	if (strString == NULL)					// Check if a string was given
		return;								// Don't render anything then

	va_start(argumentPtr, strString);			// Parse the arguments out of the string
	vsprintf(strText, strString, argumentPtr);	// Now add the arguments into the full string
	va_end(argumentPtr);						// This resets and frees the pointer to the argument list.

	MessageBox(NULL,strText,"Fatal Error!!!",MB_OK|MB_ICONSTOP);
	printf("FATAL ERROR: %s\n",strText);
}

/*=========================================================
void cMyError::AlertError()
==========================================================*/

void cMyError::AlertError(const char *strString, ...)
{
	char		strText[256];				// This will hold our text to display
	va_list		argumentPtr;				// This will hold the pointer to the argument list
	float		unitLength=0.0f;			// This will store the length of the 3D Font in unit length
		
	if (strString == NULL)					// Check if a string was given
		return;								// Don't render anything then

	va_start(argumentPtr, strString);			// Parse the arguments out of the string
	vsprintf(strText, strString, argumentPtr);	// Now add the arguments into the full string
	va_end(argumentPtr);						// This resets and frees the pointer to the argument list.

	MessageBox(NULL,strText,"Non fatal error!",MB_OK|MB_ICONEXCLAMATION);
	printf("ERROR(loud): %s\n",strText);
}

/*=========================================================
void cMyError::Error()
==========================================================*/

void cMyError::Error(const char *strString, ...)
{
	char		strText[256];				// This will hold our text to display
	va_list		argumentPtr;				// This will hold the pointer to the argument list
	float		unitLength=0.0f;			// This will store the length of the 3D Font in unit length
		
	if (strString == NULL)					// Check if a string was given
		return;								// Don't render anything then

	va_start(argumentPtr, strString);			// Parse the arguments out of the string
	vsprintf(strText, strString, argumentPtr);	// Now add the arguments into the full string
	va_end(argumentPtr);						// This resets and frees the pointer to the argument list.

	printf("ERROR(quiet): %s\n",strText);
}

/*=========================================================
void cMyError::Alert()
==========================================================*/

void cMyError::Alert(const char *strString, ...)
{
	char		strText[256];				// This will hold our text to display
	va_list		argumentPtr;				// This will hold the pointer to the argument list
	float		unitLength=0.0f;			// This will store the length of the 3D Font in unit length
		
	if (strString == NULL)					// Check if a string was given
		return;								// Don't render anything then

	va_start(argumentPtr, strString);			// Parse the arguments out of the string
	vsprintf(strText, strString, argumentPtr);	// Now add the arguments into the full string
	va_end(argumentPtr);						// This resets and frees the pointer to the argument list.

	MessageBox(NULL,strText,"Information",MB_OK);
	printf("Alert(loud): %s\n",strText);
}
/*=========================================================
void cMyError::Log()
==========================================================*/

void cMyError::Log(const char *strString, ...)
{
	char		strText[256];				// This will hold our text to display
	va_list		argumentPtr;				// This will hold the pointer to the argument list
	float		unitLength=0.0f;			// This will store the length of the 3D Font in unit length
		
	if (strString == NULL)					// Check if a string was given
		return;								// Don't render anything then

	va_start(argumentPtr, strString);			// Parse the arguments out of the string
	vsprintf(strText, strString, argumentPtr);	// Now add the arguments into the full string
	va_end(argumentPtr);						// This resets and frees the pointer to the argument list.

	printf("Log: %s\n",strText);
}